"""Data classes for torch.utils.data.Dataloader
"""
import torch
from torch.autograd import Variable
from torch.utils.data import Dataset
import numpy as np

class VerseDataset(Dataset):
    """Load train/eval data from .npy files"""
    def __init__(self, config, data_type="train"):
        super(VerseDataset, self).__init__()
        
        if data_type == "train":
            self.data = np.load(config.data_train_path, allow_pickle=True)
        elif data_type == "eval":
            self.data = np.load(config.data_eval_path, allow_pickle=True)
        else:
            raise Exception("type error, no data type as {:s}".format(data_type))

    def __getitem__(self, idx):
        # ['src', 'tgt', 'tenor', 'vehicle', 'verb', 'verb_type', 'line_idx', 'endings', 'id']
        return [self.data[idx]["src"], self.data[idx]["tgt"], \
                    self.data[idx]["tenor"], self.data[idx]["vehicle"],\
                    self.data[idx]["id"]]
        # return self.data[idx]
        
    def __len__(self):
        return len(self.data)
